

# ListPrincipalThingsV2
<a name="API_ListPrincipalThingsV2"></a>

Lists the things associated with the specified principal. A principal can be an X.509 certificate or an Amazon Cognito ID.

Requires permission to access the [ListPrincipalThings](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_ListPrincipalThingsV2_RequestSyntax"></a>

```
GET /principals/things-v2?maxResults=maxResults&nextToken=nextToken&thingPrincipalType=thingPrincipalType HTTP/1.1
x-amzn-principal: principal
```

## URI Request Parameters
<a name="API_ListPrincipalThingsV2_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_ListPrincipalThingsV2_RequestSyntax) **   <a name="iot-ListPrincipalThingsV2-request-uri-maxResults"></a>
The maximum number of results to return in this operation.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_ListPrincipalThingsV2_RequestSyntax) **   <a name="iot-ListPrincipalThingsV2-request-uri-nextToken"></a>
To retrieve the next set of results, the `nextToken` value from a previous response; otherwise **null** to receive the first set of results.

 ** [principal](#API_ListPrincipalThingsV2_RequestSyntax) **   <a name="iot-ListPrincipalThingsV2-request-principal"></a>
The principal. A principal can be an X.509 certificate or an Amazon Cognito ID.  
Required: Yes

 ** [thingPrincipalType](#API_ListPrincipalThingsV2_RequestSyntax) **   <a name="iot-ListPrincipalThingsV2-request-uri-thingPrincipalType"></a>
The type of the relation you want to filter in the response. If no value is provided in this field, the response will list all things, including both the `EXCLUSIVE_THING` and `NON_EXCLUSIVE_THING` attachment types.  
+  `EXCLUSIVE_THING` - Attaches the specified principal to the specified thing, exclusively. The thing will be the only thing that’s attached to the principal.
+  `NON_EXCLUSIVE_THING` - Attaches the specified principal to the specified thing. Multiple things can be attached to the principal.
Valid Values: `EXCLUSIVE_THING | NON_EXCLUSIVE_THING` 

## Request Body
<a name="API_ListPrincipalThingsV2_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListPrincipalThingsV2_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "principalThingObjects": [ 
      { 
         "thingName": "string",
         "thingPrincipalType": "string"
      }
   ]
}
```

## Response Elements
<a name="API_ListPrincipalThingsV2_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_ListPrincipalThingsV2_ResponseSyntax) **   <a name="iot-ListPrincipalThingsV2-response-nextToken"></a>
The token to use to get the next set of results, or **null** if there are no additional results.  
Type: String

 ** [principalThingObjects](#API_ListPrincipalThingsV2_ResponseSyntax) **   <a name="iot-ListPrincipalThingsV2-response-principalThingObjects"></a>
A list of `thingPrincipalObject` that represents the principal and the type of relation it has with the thing.  
Type: Array of [PrincipalThingObject](API_PrincipalThingObject.md) objects

## Errors
<a name="API_ListPrincipalThingsV2_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is temporarily unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** UnauthorizedException **   
You are not authorized to perform this operation.    
 ** message **   
The message for the exception.
HTTP Status Code: 401

## See Also
<a name="API_ListPrincipalThingsV2_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iot-2015-05-28/ListPrincipalThingsV2) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iot-2015-05-28/ListPrincipalThingsV2) 